'****************************************************************************
'*	Copylight(C) 2011 Kanazawa-soft-design,LLC.All Rights Reserved.
'****************************************************************************
'*
'*	@file	Form1.vb
'*
'*	@brief	VA|[gʐMvO.
'*
'*	@author	V 閾
'*
Imports System
Imports System.IO.Ports
Imports System.Text
Imports System.Drawing
Imports System.Drawing.Drawing2D


Public Class Form1

	'****************************************************************************'
	'*
	'*	@brief	{[[gi[p̃NX`.
	'*
	Private Class BuadRateItem 
		Inherits  Object

		Private m_name	As String  = ""
		Private m_value As Integer = 0

		'\
		Public Property NAME() As String
			Set(ByVal value As String)
				m_name = value
			End Set
			Get
				Return m_name
			End Get
		End Property

		'{[[gݒl.
		Public Property BAUDRATE() As Integer
			Set(ByVal value As Integer)
				m_value = value
			End Set
			Get
				Return m_value
			End Get
		End Property

		'R{{bNX\p̕擾֐.
		Public Overrides Function ToString As String
			Return m_name
		End Function

	End Class

	'****************************************************************************'
	'*
	'*	@brief	vgRi[p̃NX`.
	'*
	Private Class HandShakeItem 
		Inherits  Object

		Private m_name	As String  = ""
		Private m_value As Handshake = Handshake.None

		'\
		Public Property NAME() As String
			Set(ByVal value As String)
				m_name = value
			End Set
			Get
				Return m_name
			End Get
		End Property

		'vgRݒl.
		Public Property HANDSHAKE() As Handshake
			Set(ByVal value As Handshake)
				m_value = value
			End Set
			Get
				Return m_value
			End Get
		End Property

		'R{{bNX\p̕擾֐.
		Public Overrides Function ToString As String
			Return m_name
		End Function

	End Class

	Private Delegate Sub Delegate_RcvDataToTextBox( data As String )

	'****************************************************************************'
	'*
	'*	@brief	_CAȌ.
	'*
	'*	@param	[in]	sender	Cxg̑M̃IuWFNg.
	'*	@param	[in]	e		Cxg.
	'*
	'*	@retval	Ȃ.
	'*
	Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

		'p\ȃVA|[g̔z擾.
		Dim PortList As String()
		PortList = SerialPort.GetPortNames()

		cmbPortName.Items.Clear()

		'VA|[gR{{bNXɃZbg.
		Dim PortName As String
		For Each PortName In PortList
			cmbPortName.Items.Add(PortName)
		Next PortName

		If cmbPortName.Items.Count > 0 Then
			cmbPortName.SelectedIndex = 0
		End If

		cmbBaudRate.Items.Clear()

		'{[[gIR{{bNXɑIڂZbg.
		Dim baud As BuadRateItem
		baud		  = New BuadRateItem
		baud.NAME	  = "4800bps"
		baud.BAUDRATE = 4800
		cmbBaudRate.Items.Add(baud)

		baud		  = New BuadRateItem
		baud.NAME	  = "9600bps"
		baud.BAUDRATE = 9600
		cmbBaudRate.Items.Add(baud)

		baud		  = New BuadRateItem
		baud.NAME	  = "19200bps"
		baud.BAUDRATE = 19200
		cmbBaudRate.Items.Add(baud)

		baud		  = New BuadRateItem
		baud.NAME	  = "115200bps"
		baud.BAUDRATE = 115200
		cmbBaudRate.Items.Add(baud)
		cmbBaudRate.SelectedIndex = 1

		cmbHandShake.Items.Clear()

		't[IR{{bNXɑIڂZbg.
		Dim ctrl As HandShakeItem
		ctrl		   = New HandShakeItem
		ctrl.NAME	   = "Ȃ"
		ctrl.HANDSHAKE = Handshake.None
		cmbHandShake.Items.Add(ctrl)

		ctrl		   = New HandShakeItem
		ctrl.NAME	   = "XON/XOFF"
		ctrl.HANDSHAKE = Handshake.XOnXOff
		cmbHandShake.Items.Add(ctrl)

		ctrl		   = New HandShakeItem
		ctrl.NAME	   = "RTS/CTS"
		ctrl.HANDSHAKE = Handshake.RequestToSend
		cmbHandShake.Items.Add(ctrl)

		ctrl		   = New HandShakeItem
		ctrl.NAME	   = "XON/XOFF + RTS/CTS"
		ctrl.HANDSHAKE = Handshake.RequestToSendXOnXOff
		cmbHandShake.Items.Add(ctrl)
		cmbHandShake.SelectedIndex = 0

		'Mp̃eLXg{bNXNA.
		SndTextBox.Clear()
        RcvTextBox.Clear()

        'FORM2\
        Me.AddOwnedForm(Form2)
        Form2.Show()
        Form2.TransparencyKey = Me.BackColor

        Form2.Left = Me.Left + 27
        Form2.Top = Me.Top + 285

        ComboBox1.SelectedIndex = 0



    End Sub

	'****************************************************************************'
	'*
	'*	@brief	_CAȌI.
	'*
	'*	@param	[in]	sender	Cxg̑M̃IuWFNg.
	'*	@param	[in]	e		Cxg.
	'*
	'*	@retval	Ȃ.
	'*
	Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

		'VA|[gI[vĂꍇAN[Y.
		If SerialPort1.IsOpen Then
			SerialPort1.Close()
		End If

	End Sub

	'****************************************************************************'
	'*
	'*	@brief	[I]{^Ƃ̏.
	'*
	'*	@param	[in]	sender	Cxg̑M̃IuWFNg.
	'*	@param	[in]	e		Cxg.
	'*
	'*	@retval	Ȃ.
	'*
	Private Sub ExitButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitButton.Click

		'_CAON[Y.
		Me.Close()

	End Sub

	'****************************************************************************'
	'*
	'*	@brief	[ڑ]/[ؒf]{^ƂɃVA|[g̃I[v/N[Ys.
	'*
	'*	@param	[in]	sender	Cxg̑M̃IuWFNg.
	'*	@param	[in]	e		Cxg.
	'*
	'*	@retval	Ȃ.
	'*
	Private Sub ConnectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectButton.Click

		If SerialPort1.IsOpen = True Then

			'VA|[gN[Y.
			SerialPort1.Close()

			'{^̕\[ؒf][ڑ]ɕς.
			ConnectButton.Text = "ڑ"
		Else

			'I[vVA|[gR{{bNXo.
			SerialPort1.PortName = cmbPortName.SelectedItem.ToString()

			'{[[gR{{bNXo.
			Dim baud As BuadRateItem
			baud = cmbBaudRate.SelectedItem
			SerialPort1.BaudRate = baud.BAUDRATE

			'f[^rbgZbg. (f[^rbg = 8rbg)
			SerialPort1.DataBits = 8

			'peBrbgZbg. (peBrbg = Ȃ)
			SerialPort1.Parity = Parity.None

			'XgbvrbgZbg. (Xgbvrbg = 1rbg)
			SerialPort1.StopBits = StopBits.One

			't[R{{bNXo.
			Dim ctrl As HandShakeItem
			ctrl = cmbHandShake.SelectedItem
			SerialPort1.Handshake = ctrl.HANDSHAKE

            'R[hZbg.
            SerialPort1.Encoding = Encoding.ASCII

            Try
				'VA|[gI[v.
				SerialPort1.Open()

				'{^̕\[ڑ][ؒf]ɕς.
				ConnectButton.Text = "ؒf"
			Catch ex As Exception
				MsgBox( ex.Message )
			End Try

		End If

	End Sub

	'****************************************************************************'
	'*
	'*	@brief	[M]{^āAf[^Ms.
	'*
	'*	@param	[in]	sender	Cxg̑M̃IuWFNg.
	'*	@param	[in]	e		Cxg.
	'*
	'*	@retval	Ȃ.
	'*
	Private Sub SndButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SndButton.Click

		'VA|[gI[vĂȂꍇAsȂ.
		If SerialPort1.IsOpen = False Then
			Return
		End If

		'eLXg{bNXAMeLXgo.
		Dim data As String
		data = SndTextBox.Text

		'MeLXgȂꍇAf[^M͍sȂ.
		If String.IsNullOrEmpty(data) Then
			Return
		End If

		Try
			'VA|[geLXg𑗐M.
			SerialPort1.Write(data)

			'Mf[^͂eLXg{bNXNA.
			SndTextBox.Clear()
		Catch ex As Exception
			MsgBox( ex.Message )
		End Try

	End Sub

	'****************************************************************************'
	'*
	'*	@brief	f[^MƂ̃Cxg.
	'*
	'*	@param	[in]	sender	Cxg̑M̃IuWFNg.
	'*	@param	[in]	e		Cxg.
	'*
	'*	@retval	Ȃ.
	'*
	Private Sub SerialPort1_DataReceived(ByVal sender As System.Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived

		'VA|[gI[vĂȂꍇAsȂ.
		If SerialPort1.IsOpen = False Then
			Return
		End If

		Try
			'Mf[^ǂݍ.
			Dim data As String
			data = SerialPort1.ReadExisting()

            'Mf[^eLXg{bNXɏA`悷
            Dim args(0) As Object
			args(0) = data
            Invoke(New Delegate_RcvDataToTextBox(AddressOf Me.RcvDataToTextBox), args)



        Catch ex As Exception
			MsgBox( ex.Message )
		End Try

	End Sub


    Dim Buffer As String
    Dim bairitu As Double

    '****************************************************************************'
    '*
    '*	@brief	Mf[^eLXg{bNXɏ`悷
    '*
    '*	@param	[in]	data	M.
    '*
    '*	@retval	Ȃ.
    '*

    Private Sub RcvDataToTextBox( data As String )


        Dim datada As String = ""


        'Mf[^eLXg{bNX̍ŌɒǋLA`vV[WɊpxƁAn
        If IsNothing( data ) = False Then

            RcvTextBox.AppendText(data)

            Buffer = Buffer & data
            ' TextBox1.AppendText(Buffer & vbCrLf)

            If Buffer.IndexOf("E") <> -1 Then
                datada = Buffer.Replace("E", "")
                datada = datada.Replace("S", "")
                byouga(datada)
                Buffer = ""
            End If

        End If

    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick

        'VA|[gI[vĂȂꍇAsȂ.
        If SerialPort1.IsOpen = False Then
            Return
        End If

        'eLXg{bNXAMeLXgo.
        Dim data As String
        data = "1"

        'MeLXgȂꍇAf[^M͍sȂ.
        If String.IsNullOrEmpty(data) Then
            Return
        End If

        Try
            'VA|[geLXg𑗐M.
            SerialPort1.Write(data)


        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub
    Dim kakudoold
    Private Sub byouga(outdata As String)
        Dim nagasa As Integer = 500

        'ox(outdata)
        Dim arr1() As String = outdata.Split(",")
        Dim kyori As Double = Double.Parse(arr1(1))
        Dim XX As Integer
        Dim YY As Integer
        Dim KAKUDO As Integer = Integer.Parse(arr1(0))

        Dim radian As Double = Math.PI * KAKUDO / 180.0
        Dim hyaku = Math.PI

        '\NA

        If kakudoold = 0 Or kakudoold = 180 Then

            If CheckBox1.Checked = True Then
                RcvTextBox.Text = ""
                shokika()

            End If

        End If


        'Jn
        kyori = bairitu * kyori

        If KAKUDO < 90 Then
                XX = kyori * Math.Cos(radian) + 300
                YY = 300 - kyori * Math.Sin(radian)

            Else
                XX = 300 - kyori * Math.Cos(hyaku - radian)
                YY = 300 - kyori * Math.Sin(hyaku - radian)


            End If
            PictureBox1.CreateGraphics.DrawEllipse(Pens.Black, XX, YY, 1, 1)

        'Form2.PictureBox1.Image = Nothing
        '
        Form2.PictureBox1.CreateGraphics.Clear(SystemColors.Control)

        If KAKUDO < 90 Then
            XX = nagasa * Math.Cos(radian) + 300
            YY = 300 - nagasa * Math.Sin(radian)

        Else
            XX = 300 - nagasa * Math.Cos(hyaku - radian)
            YY = 300 - nagasa * Math.Sin(hyaku - radian)


        End If

        Form2.PictureBox1.CreateGraphics.DrawLine(Pens.Blue, 300, 300, XX, YY)


        kakudoold = KAKUDO


    End Sub



    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        '
        shokika()

        Timer1.Enabled = True

    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Timer1.Enabled = False
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click

        'VA|[gI[vĂȂꍇAsȂ.
        If SerialPort1.IsOpen = False Then
            Return
        End If

        'eLXg{bNXAMeLXgo.
        Dim data As String
        data = "1"

        'MeLXgȂꍇAf[^M͍sȂ.
        If String.IsNullOrEmpty(data) Then
            Return
        End If

        Try
            'VA|[geLXg𑗐M.
            SerialPort1.Write(data)


        Catch ex As Exception
            MsgBox(ex.Message)

        End Try



    End Sub

    Private Sub shokika()

        Dim intIdx As Integer = Me.ComboBox1.SelectedIndex + 1
        bairitu = 3 / intIdx

        Dim i As Integer
        '
        PictureBox1.CreateGraphics.Clear(Color.White)
        Me.CreateGraphics.Clear(SystemColors.Control)
        'PenIuWFNg̍쐬(5̍F)
        Dim blackPen As New Pen(Color.FromArgb(200, 200, 200), 1)
        Dim redPen As New Pen(Color.Red, 3)

        '_bV
        blackPen.DashStyle = DashStyle.Dash

        '
        For i = 1 To 2
            PictureBox1.CreateGraphics.DrawLine(blackPen, 0, 100 * i, 600, 100 * i)
        Next i

        'c
        For i = 1 To 5
            PictureBox1.CreateGraphics.DrawLine(blackPen, 100 * i, 0, 100 * i, 300)
        Next i
        'ZT[ʒuL
        PictureBox1.CreateGraphics.DrawEllipse(redPen, 295, 295, 10, 10)

        PictureBox1.CreateGraphics.DrawEllipse(blackPen, 200, 200, 200, 200)
        PictureBox1.CreateGraphics.DrawEllipse(blackPen, 100, 100, 400, 400)
        PictureBox1.CreateGraphics.DrawEllipse(blackPen, 0, 0, 600, 600)

        'tHgIuWFNg̍쐬
        Dim fnt As New Font("MS UI Gothic", 12)

        Dim m3 As Double = 3 / bairitu
        Dim m2 As Double = 2 / bairitu
        Dim m1 As Double = 1 / bairitu

        Dim mn3 As String = m3.ToString("0.0") & "m"
        Dim mn2 As String = m2.ToString("0.0") & "m"
        Dim mn1 As String = m1.ToString("0.0") & "m"

        Me.CreateGraphics.DrawString(mn3, fnt, Brushes.Blue, 620, 249)
        Me.CreateGraphics.DrawString(mn2, fnt, Brushes.Blue, 620, 349)
        Me.CreateGraphics.DrawString(mn1, fnt, Brushes.Blue, 620, 449)
        Me.CreateGraphics.DrawString("0m", fnt, Brushes.Blue, 620, 544)

        Me.CreateGraphics.DrawString(mn3, fnt, Brushes.Blue, 9, 558)
        Me.CreateGraphics.DrawString(mn2, fnt, Brushes.Blue, 109, 558)
        Me.CreateGraphics.DrawString(mn1, fnt, Brushes.Blue, 209, 558)
        Me.CreateGraphics.DrawString("0m", fnt, Brushes.Blue, 309, 558)
        Me.CreateGraphics.DrawString(mn1, fnt, Brushes.Blue, 409, 558)
        Me.CreateGraphics.DrawString(mn2, fnt, Brushes.Blue, 509, 558)
        Me.CreateGraphics.DrawString(mn3, fnt, Brushes.Blue, 609, 558)

    End Sub




    Private Sub Button4_Click(sender As Object, e As EventArgs)

        Me.AddOwnedForm(Form2)
        Form2.Show()
        Form2.TransparencyKey = Me.BackColor

        Form2.Left = Me.Left + 18
        Form2.Top = Me.Top + 255

        Form2.PictureBox1.CreateGraphics.DrawLine(Pens.Blue, 300, 300, 2, 200)



    End Sub

    Private Sub Form1_Move(sender As Object, e As EventArgs) Handles Me.Move


        Form2.Left = Me.Left + 27
        Form2.Top = Me.Top + 285

    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs)
        MsgBox(ComboBox1.Items)
    End Sub
End Class
